/**
 * apigateway服务
 * @class apigateway
 * @param {Object} [opts={}] 参数
 * @example
 * opts参数:{
 *  services: (必填, 需要转发的服务)
 * }
 * @returns {Object}
 * @example
 * 返回结果: apigateway对象
 */
var cluster = require('cluster');
var jm = require('jm-ms');
var ms = jm.ms;
module.exports = function(opts){
    opts = opts || {};
    var package = require('../package.json');
    var router = ms();
    var help = function(opts, cb){
        var o = {
            name: package.name,
            version: package.version
        };
        if (cluster.isWorker) {
            o.clusterId = cluster.worker.id;
        }
        cb(null, o);
    };
    router.add('/', 'get', help);
    router.addService = function(name, opts) {
        var router = ms();
        var prefix = '/' + name;
        ms.client(opts, function(err, client){
            router.use(function(opts, cb) {
                client.request(opts, cb);
            });
        });
        this.use(prefix, router);
    };

    router.addServices = function(opts) {
        for(var name in opts){
            this.addService(name, opts[name]);
        }
    };

    if(opts.services) router.addServices(opts.services);
    return router;
};
